//+------------------------------------------------------------------+
//|                                                         MyEA.mq4 |
//|                                                       Belluolisa |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Belluolisa"
#property link      ""
#property version   "1.00"
#property strict
enum ITV
{
   IT_V1  = 0,  //I_Trend Value 1
   IT_V2 = 1,  //I_Trend Value 2
   IT_V1_2 = 2,  //I_Trend Both Values
};
enum MAP
{
   MAP1 = 0,  //1 Moving Average
   MAP2 = 1,  //2 Moving Average
   MAP3 = 2,  //3 Moving Average
};
extern string Hdr0 = "================= EA Inputs ====================";
extern int MagicNumber = 23354;
extern string Hdr1 = ">>> MONEY MANAGEMENT";
extern string Hlp1 = "LotSize: Automoney management=0";
extern double LotSize = 0;
extern string Hlp1a = "RiskBasis: on equity=0, on stoploss=1";
extern int RiskBasis = 0;
extern double MaximumRiskPercentage = 2;
extern string Hlp1b = "TradeClosureMode: Use StopLoss=0, Use Signal Reversal=1, Use TradersDynamicIndex=2";
extern int TradeClosureMode = 0;
extern string Hlp1c = "If Trade Closure Mode=1 or 2, or for StopLoss using ATR, use StopLoss=0";
extern int StopLoss = 10;
extern int StopLossATRPeriods = 0;
extern double StopLossMultiplier = 0;
extern string Hlp1d = "UseTrailingStopLoss: No=0, Yes=1";
extern int UseTrailingStopLoss = 1;
extern string Hlp1e = "For TakeProfit using ATR, use TakeProfit=0";
extern int TakeProfit = 10;
extern int TakeProfitATRPeriods = 0;
extern double TakeProfitMultiplier = 0;
extern string Hlp1f = "SetStopLossToBreakEvenPips: no profit protection=0, protect loss at ?? pip gain=??";
extern int SetStopLossToBreakEvenPips = 0;
extern string Hdr2 = ">>> Minimum Pip Gain To Reset StopLossMultiplier";
extern int MinPipGainReset = 5;
extern string Hdr3 = ">>> Decrease Stop Loss % On Profit Gain Of 5%";
extern double DecrStopLossPercent = 0;
extern int MaxSlippage = 1;
extern int MaxSpread = 5;
extern string Hdr4 = "============= i_Trend Indicator ==============";
extern bool Use_iTrend = False;//Use iTrend Indicator
extern ITV iTrendValue = IT_V1;//iTrend Value choosen
extern double ValueLimit = 0.0010; //Limit for Value(s)
extern string Hdr5 = "============= Bulls and Bears Power Indicator ==============";
extern bool Use_BullsBears = False; //Use Bulls and Bears Power Indicator
extern bool Use_Divergence = False; //Divergence Rule
extern int DivergencePeriod = 10; //Divergence lookback
extern string Hdr6 = "============= Moving Average Indicator ==============";
extern bool Use_MovingAverage = False;//Use Moving Average Indicator
extern MAP MovingAverageAmount = MAP2;//Moving Average Amount
extern int Period1 = 4;
extern int Shift1 = -4;
extern int Method1 = 1;
extern int Applied_Price1 = 0;
extern int Period2 = 9;
extern int Shift2 = -4;
extern int Method2 = 1;
extern int Applied_Price2 = 0;
extern int Period3 = 18;
extern int Shift3 = -4;
extern int Method3 = 1;
extern int Applied_Price3 = 0;
extern string Hdr7 = ">>> Use Trix Indicator";
extern bool Use_TrixMovingAverage = False;//Use Trix Moving Average Indicator

double iTrendValue1, iTrendValue2, ShiftiTrendValue1, ShiftiTrendValue2, BullsPower, ShiftBullsPower, BearsPower, ShiftBearsPower, BullsDivergence, BullsDivergence1,
BearsDivergence, BearsDivergence1, FastMA, FastMAPrevious, MediumMA, SlowMA, TrixValue1, TrixValue2, TakeWinPrice, CurrProfitTarget, PointValue,
StopLossPrice, StopLevel, PrevOpen, PrevValue, PrevBid, PrevStopLossPrice, Wager, PrevWager, Spread, BreakEvenPrice, CurrPrice, PrevPrice,
RSIBuffer[9], TDIBuffer[8]; 

bool iTrendSell, iTrendBuy, BullsPowerBuy,BearsPowerSell, DivergenceSell, DivergenceBuy, MABuy, MASell,TrixBuy, TrixSell, MAMixBuy, MAMixSell, BullsBearsMixBuy, BullsBearsMixSell;

int i, PrevEquity, ConsecLosses, CapReached, Buys, Sells, BuyStops, SellStops, Shift, Modified, BreakEvenCompleted, res, BuyBarCross, SellBarCross, ObjectCount, DisableTrading, AdjStopLoss, BuyTDIReturnValue, SellTDIReturnValue, TDIBuySignal, TDISellSignal,
CurrentMinute, CurrentHour, CurrentDay;

string Comment1;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(TradeClosureMode > 0)
    {
    StopLoss = 0;
    TakeProfit = 0;
    }
  if(StringFind(Symbol(),"JPY") > (-1)) PointValue = .01;
  else if(StringFind(Symbol(),"XAU") > (-1)) PointValue = .1;
  else if(StringFind(Symbol(),"GOLD") > (-1)) PointValue = .1;
  else if(StringFind(Symbol(),"XAG") > (-1)) PointValue = .01;
  else if(StringFind(Symbol(),"SILVER") > (-1)) PointValue = .01;
  else PointValue = .00001;
  DisableTrading = 0;
  for(i=0;i<OrdersTotal();i++)
     {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
     if(OrderType()==OP_BUYLIMIT) DisableTrading = 1;
     } 
  if(CalculateCurrOrders(Symbol())== 0)
    {
    if (DisableTrading == 0)CheckForOpen();
    }
  else
    { 
    if (TradeClosureMode == 1 && DisableTrading == 0) CheckForOpen();
    if (DisableTrading == 0)CheckForClose();
    if (DisableTrading == 0)CheckForModify();
    }
  } 
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrOrders(string symbol)
  {
  Buys=0;
  Sells=0;
  BuyStops=0;
  SellStops=0;
//----
   for(i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         if(OrderType()==OP_BUY) 
           {
           Buys++;
           Wager = OrderLots();
           }
         if(OrderType()==OP_SELL) 
           {
           Sells++;
           Wager = OrderLots();
           }
         if(OrderType()==OP_BUYSTOP)  BuyStops++;
         if(OrderType()==OP_SELLSTOP) SellStops++;
        }
     }

//---- return orders volume
 
   if(Buys>0) return(Buys);
   else       return(-Sells);
  }
 //+------------------------------------------------------------------+
//| Check for Close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
    if (TradeClosureMode == 2 && (Buys > 0 || Sells > 0)) 
       {
       for(Shift = 1; Shift < 2; Shift++)
          {
          CalcTDI(Shift);
          ProcessBuyTDICross();
          ProcessSellTDICross();
          }
       if (BuyTDIReturnValue == 0 && SellTDIReturnValue == 0) return;
       }
    if ((TradeClosureMode == 1 || (TradeClosureMode == 2 && BuyTDIReturnValue == 1))  && Sells > 0)
       {
       for (i = OrdersTotal()-1; i >= 0; i--) 
           { 
           res = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
           if (OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == MagicNumber) 
              {
              if (iTrendBuy == False  && Use_iTrend == True && (iTrendValue == IT_V1 || iTrendValue == IT_V2 || iTrendValue == IT_V1_2)) return;
              if (BullsPowerBuy == False  && Use_BullsBears == True && Use_Divergence == False) return;
              if (DivergenceBuy == False && Use_Divergence == True && Use_BullsBears == False) return;
              if (BullsBearsMixBuy == False && Use_BullsBears == True && Use_Divergence == True) return;
              if (MABuy == False  && Use_MovingAverage == True && Use_TrixMovingAverage == False && (MovingAverageAmount == MAP1 || MovingAverageAmount == MAP2 || MovingAverageAmount == MAP3)) return;
              if (TrixBuy == False && Use_MovingAverage == False && Use_TrixMovingAverage == True) return;
              if (MAMixBuy == False && Use_MovingAverage == True && Use_TrixMovingAverage == True) return;
              res = OrderClose(OrderTicket(),OrderLots(),Ask,1,clrMaroon);
              return;
              }
           } 
       } 
    if ((TradeClosureMode == 1 || (TradeClosureMode == 2 && SellTDIReturnValue == 1))  && Buys > 0)
       {
       for (i = OrdersTotal()-1; i >= 0; i--) 
           { 
           res = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
           if (OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == MagicNumber) 
              {
              if (iTrendSell == False  && Use_iTrend == True && (iTrendValue == IT_V1 || iTrendValue == IT_V2 || iTrendValue == IT_V1_2)) return;
              if (BearsPowerSell == False  && Use_BullsBears == True && Use_Divergence == False) return;
              if (DivergenceSell == False && Use_Divergence == True && Use_BullsBears == False) return;
              if (BullsBearsMixSell == False && Use_BullsBears == True && Use_Divergence == True) return;
              if (MASell == False  && Use_MovingAverage == True && Use_TrixMovingAverage == False && (MovingAverageAmount == MAP1 || MovingAverageAmount == MAP2 || MovingAverageAmount == MAP3)) return;
              if (TrixSell == False && Use_MovingAverage == False && Use_TrixMovingAverage == True) return;
              if (MAMixSell == False && Use_MovingAverage == True && Use_TrixMovingAverage == True) return;
              res = OrderClose(OrderTicket(),OrderLots(),Bid,1,clrMaroon);
              return;
              }
           } 
       } 
  } 
//+------------------------------------------------------------------+
//| Calculate TDI                                                    |
//+------------------------------------------------------------------+
void CalcTDI(int ShiftVal)
  {
  for (i=9; i>=0; i--)
      {
      RSIBuffer[i] = (iRSI(NULL,0,13,PRICE_CLOSE,i)); 
      } 
  for (i=8; i>=0; i--)
      {
      TDIBuffer[i] = (iMAOnArray(RSIBuffer,0,7,0,MODE_SMA,i)); 
      }  
  }
//+------------------------------------------------------------------+
//| Process Buy TDI Cross                                            |
//+------------------------------------------------------------------+
void ProcessBuyTDICross()
  {
  if ((TDIBuffer[1] > 50)) BuyTDIReturnValue = 1;
  else BuyTDIReturnValue = 0;  
  }
//+------------------------------------------------------------------+
//| Process Sell TDI Cross                                           |
//+------------------------------------------------------------------+
void ProcessSellTDICross()
  {
  if ((TDIBuffer[1] < 50)) SellTDIReturnValue = 1;
  else SellTDIReturnValue = 0;  
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
 {
   if (Use_iTrend == True)
   {
   iTrendBuy = False;
   iTrendSell = False;
   iTrend();
   }
   if (Use_BullsBears == True && Use_Divergence == False)
   {
   BullsPowerBuy = False;
   BearsPowerSell = False;
   BullsBearsPower();
   }
   if (Use_BullsBears == False && Use_Divergence == True)
   {
   DivergenceBuy = False;
   DivergenceSell = False;
   Divergence();
   }
   if (Use_BullsBears == True && Use_Divergence == True)
   {
   BullsBearsMixBuy = False;
   BullsBearsMixSell = False;
   BullsBearsMix();
   }
   if (Use_MovingAverage == True && Use_TrixMovingAverage == False)
   {
   MABuy = False;
   MASell = False;
   MovingAverage();
   }
   if (Use_MovingAverage == False && Use_TrixMovingAverage == True)
   {
   TrixBuy = False;
   TrixSell = False;
   Trix();
   }
   if (Use_MovingAverage == True && Use_TrixMovingAverage == True)
   {
   MAMixBuy = False;
   MAMixSell = False;
   MATrixMix();
   }
   if (TradeClosureMode > 0 && (Buys > 0 || Sells > 0)) CheckForClose();
    
    CalculateCurrOrders(Symbol());
    
    if (Buys > 0 || Sells > 0) return;
    
    ProcessBuyOrder();
    ProcessSellOrder();  
  }
//+------------------------------------------------------------------+
//| Process Buy Order conditions                                     |
//+------------------------------------------------------------------+
void ProcessBuyOrder()
{   
   if (iTrendBuy == False  && Use_iTrend == True && (iTrendValue == IT_V1 || iTrendValue == IT_V2 || iTrendValue == IT_V1_2)) return;
   if (BullsPowerBuy == False  && Use_BullsBears == True && Use_Divergence == False) return;
   if (DivergenceBuy == False && Use_Divergence == True && Use_BullsBears == False) return;
   if (BullsBearsMixBuy == False && Use_BullsBears == True && Use_Divergence == True) return;
   if (MABuy == False  && Use_MovingAverage == True && Use_TrixMovingAverage == False && (MovingAverageAmount == MAP1 || MovingAverageAmount == MAP2 || MovingAverageAmount == MAP3)) return;
   if (TrixBuy == False && Use_MovingAverage == False && Use_TrixMovingAverage == True) return;
   if (MAMixBuy == False && Use_MovingAverage == True && Use_TrixMovingAverage == True) return;
   CurrPrice = iOpen(Symbol(),60,0);
   if (res != 2) OpenBuyOrder();
       return;
}
//+------------------------------------------------------------------+
//| Process Sell Order                                               |
//+------------------------------------------------------------------+
void ProcessSellOrder()
{
 if (iTrendSell == False  && Use_iTrend == True && (iTrendValue == IT_V1 || iTrendValue == IT_V2 || iTrendValue == IT_V1_2)) return;
 if (BearsPowerSell == False  && Use_BullsBears == True && Use_Divergence == False) return;
 if (DivergenceSell == False && Use_Divergence == True && Use_BullsBears == False) return;
 if (BullsBearsMixSell == False && Use_BullsBears == True && Use_Divergence == True) return;
 if (MASell == False  && Use_MovingAverage == True && Use_TrixMovingAverage == False && (MovingAverageAmount == MAP1 || MovingAverageAmount == MAP2 || MovingAverageAmount == MAP3)) return;
 if (TrixSell == False && Use_MovingAverage == False && Use_TrixMovingAverage == True) return;
 if (MAMixSell == False && Use_MovingAverage == True && Use_TrixMovingAverage == True) return;
 CurrPrice = iOpen(Symbol(),60,0);
 if (res != 2) OpenSellOrder();
       return;
}
//+------------------------------------------------------------------+
//| Set Wager                                                        |
//+------------------------------------------------------------------+
void SetWager()
   {
   Wager = LotSize;
   if (LotSize == 0  && RiskBasis == 0) Wager = NormalizeDouble(AccountEquity() * MaximumRiskPercentage / 100000,2);
   if (LotSize == 0  && RiskBasis == 1) Wager = NormalizeDouble(AccountEquity() * MaximumRiskPercentage / 1000 / StopLoss,2);
   if (StopLossATRPeriods == 0 && StopLossMultiplier != 0 && PrevWager != 0  && AccountEquity() < PrevEquity + (MinPipGainReset * Wager * 10) && PrevEquity != 0) 
      {
      Wager = PrevWager * StopLossMultiplier;
      ConsecLosses = ConsecLosses + 1;
      }
   else  ConsecLosses = 0;

   if (TakeProfitATRPeriods == 0 && TakeProfitMultiplier != 0) TakeProfit = StopLoss * TakeProfitMultiplier;

   // Set Wager to Original
   if (CapReached == 1) 
      {
      Wager =  NormalizeDouble(AccountEquity() * MaximumRiskPercentage / 100000,2); 
      CapReached = 0;
      ConsecLosses = 0;
      }

   // Cap at 20% Equity
   if ((Wager > NormalizeDouble(AccountEquity() * 20 / 100000,2)) &&  LotSize == 0  && RiskBasis == 0)
      {
      Wager = NormalizeDouble(AccountEquity() * 20 / 100000,2);
      CapReached = 1;
      }

   PrevWager = Wager;
   PrevEquity = AccountEquity();
   AdjStopLoss = StopLoss;
   }
//+------------------------------------------------------------------+
//| Open Buy Order                                                   |
//+------------------------------------------------------------------+
void OpenBuyOrder()
   {
       Comment1 = StringConcatenate(Symbol()," BUY ");
       if ((Ask - Bid) > (MaxSpread * PointValue)) return; 
       SetWager();
       res=OrderSend(Symbol(),OP_BUY,Wager,Ask,MaxSlippage,0,0,Comment1,MagicNumber,0, Green);
       // calculate stop loss and take profit levels
       PrevPrice = CurrPrice;
       StopLossPrice = 0;
       if (StopLoss == 0 && MABuy == True) StopLoss = (Close[0]-Low[2]) / PointValue;
       if (StopLoss != 0) StopLossPrice = Bid - (StopLoss * PointValue);
       if (StopLossATRPeriods != 0) StopLossPrice = Bid - (iATR(Symbol(),0,StopLossATRPeriods,0)* StopLossMultiplier);
       if (TakeProfit != 0) TakeWinPrice = Ask + (TakeProfit * PointValue); 
       if (TakeProfitATRPeriods != 0) TakeWinPrice = Ask + (iATR(Symbol(),0,TakeProfitATRPeriods,0)* TakeProfitMultiplier);
       res = OrderModify(res,OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0,clrMaroon);
       if (res > -1)
          { 
          CurrProfitTarget = Wager / Close[0]  * .005 / PointValue;
          Modified = 1;
          BreakEvenCompleted = 0;
          }
   }
//+------------------------------------------------------------------+
//| Open Sell Order                                                  |
//+------------------------------------------------------------------+
void OpenSellOrder()
  {
       Comment1 = StringConcatenate(Symbol()," SELL ");
       if ((Ask - Bid) > (MaxSpread * PointValue)) return; 
       SetWager();
       res=OrderSend(Symbol(),OP_SELL,Wager,Bid,MaxSlippage,0,0,Comment1,MagicNumber,0,Green);
       // calculate stop loss and take profit levels
       StopLossPrice = 0;
       PrevPrice = CurrPrice;
       if (StopLoss == 0 && MASell == True) StopLoss = (High[2]-Close[0])/ PointValue;
       if (StopLoss != 0) StopLossPrice = Ask + (StopLoss * PointValue);
       if (StopLossATRPeriods != 0) StopLossPrice = Ask + (iATR(Symbol(),0,StopLossATRPeriods,0)* StopLossMultiplier);
       if (TakeProfit != 0) TakeWinPrice = Bid - (TakeProfit * PointValue);
       if (TakeProfitATRPeriods != 0) TakeWinPrice = Bid - (iATR(Symbol(),0,TakeProfitATRPeriods,0)* TakeProfitMultiplier);
       res = OrderModify(res,OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0,clrMaroon);
       if (res > -1)
          {
          CurrProfitTarget = Wager / Close[0]  * .005 / PointValue;
          Modified = 1;
          BreakEvenCompleted = 0;
          }
  }
//+------------------------------------------------------------------+
//| Check for modify order conditions                                |
//+------------------------------------------------------------------+
void CheckForModify()
{
  // Delete Accidental Trades
  for(i=OrdersTotal();i>0;i--)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
         if(OrderType() == OP_BUY && Buys > 1) res = OrderClose(OrderTicket(),OrderLots(),Ask,1,clrMaroon);
         if(OrderType() == OP_SELL && Sells > 1) res = OrderClose(OrderTicket(),OrderLots(),Bid,1,clrMaroon);
         }
      }   

  for(i=0;i<OrdersTotal();i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
         if (Modified == 0)
            {
            if (OrderType()==OP_BUY) 
               {
               if (StopLoss != 0) StopLossPrice = Bid - (StopLoss * PointValue);
               if (StopLossATRPeriods != 0) StopLossPrice = Bid - (iATR(Symbol(),0,StopLossATRPeriods,0)* StopLossMultiplier);
               if (TakeProfit != 0) TakeWinPrice = Ask + (TakeProfit * PointValue); 
               if (TakeProfitATRPeriods != 0) TakeWinPrice = Ask + (iATR(Symbol(),0,TakeProfitATRPeriods,0)* TakeProfitMultiplier);
               res = OrderModify(OrderTicket(),OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0, clrMaroon);
               if (res > -1) 
                  {
                  CurrProfitTarget = Wager / Close[0]  * 50;
                  if (Close[0] > OrderOpenPrice()) AdjStopLoss = StopLoss - ((Close[0] - OrderOpenPrice()) / PointValue * DecrStopLossPercent / 10);
                  Modified = 1;
                  return;
                  }
               }
            if (OrderType()==OP_SELL) 
               {
               if (StopLoss != 0) StopLossPrice = Ask + (StopLoss * PointValue);
               if (StopLossATRPeriods != 0) StopLossPrice = Ask + (iATR(Symbol(),0,StopLossATRPeriods,0)* StopLossMultiplier);
               if (TakeProfit != 0) TakeWinPrice = Bid - (TakeProfit * PointValue);   
               if (TakeProfitATRPeriods != 0) TakeWinPrice = Bid - (iATR(Symbol(),0,TakeProfitATRPeriods,0)* TakeProfitMultiplier);
               res = OrderModify(OrderTicket(),OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0, clrMaroon);
               if (res > -1) 
                  {
                  CurrProfitTarget = Wager / Close[0]  * 50;
                  Modified = 1;
                  if (Close[0] < OrderOpenPrice()) AdjStopLoss = StopLoss - ((OrderOpenPrice() - Close[0])  / PointValue * DecrStopLossPercent / 10);
                  return;
                  }
               }
            }

         // For all trades
         if (Modified == 1)
            {
            Spread = Ask - Bid;
            if (OrderType()==OP_BUY && SetStopLossToBreakEvenPips != 0 
            && OrderProfit() >= Wager * SetStopLossToBreakEvenPips * 10
            && OrderProfit() < Wager * AdjStopLoss * 10
            && BreakEvenCompleted == 0)
               {
               StopLossPrice = OrderOpenPrice() + Spread + PointValue;
               res = OrderModify(OrderTicket(),OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0, clrMaroon);
               if (res > -1) 
                  {
                  CurrProfitTarget = Wager / Close[0]  * 50;
                  BreakEvenCompleted = 1;
                  BreakEvenPrice = StopLossPrice;
                  AdjStopLoss = StopLoss - (SetStopLossToBreakEvenPips * DecrStopLossPercent / 10);
                  }
               }
            if (OrderType()==OP_SELL && SetStopLossToBreakEvenPips != 0 
            && OrderProfit() >= Wager * SetStopLossToBreakEvenPips * 10
            && OrderProfit() < Wager * AdjStopLoss * 10
            && BreakEvenCompleted == 0)
               {
               StopLossPrice = OrderOpenPrice() - Spread - PointValue;
               res = OrderModify(OrderTicket(),OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0, clrMaroon);
               if (res > -1) 
                  {
                  CurrProfitTarget = Wager / Close[0]  * 50;
                  BreakEvenCompleted = 1;
                  BreakEvenPrice = StopLossPrice;
                  AdjStopLoss = StopLoss - (SetStopLossToBreakEvenPips * DecrStopLossPercent / 10);
                  }
               }
            if (BreakEvenCompleted == 1 && OrderType()==OP_BUY && Bid - (AdjStopLoss * PointValue) < BreakEvenPrice) return;   
            if (BreakEvenCompleted == 1 && OrderType()==OP_SELL && Ask + (AdjStopLoss * PointValue) > BreakEvenPrice) return;   
            if (OrderProfit() > CurrProfitTarget && ((OrderType()==OP_BUY)|| (OrderType()==OP_SELL))) 
               {
               if (OrderType()==OP_BUY && UseTrailingStopLoss == 1 && TradeClosureMode == 0) StopLossPrice = Bid - (AdjStopLoss * PointValue);
               if (OrderType()==OP_SELL && UseTrailingStopLoss == 1 && TradeClosureMode == 0) StopLossPrice = Ask + (AdjStopLoss * PointValue); 
               if (UseTrailingStopLoss == 1 && TradeClosureMode == 0) res = OrderModify(OrderTicket(),OrderOpenPrice(),StopLossPrice, TakeWinPrice, 0, clrMaroon);
               if (res > -1) 
                  {
                  CurrProfitTarget = OrderProfit() + (Wager / Close[0]  * 50);
                  if (AdjStopLoss > 5) AdjStopLoss = MathRound(AdjStopLoss * (100-DecrStopLossPercent) / 100);
                  }
               } 
            }
         }
      } 
  }
//+------------------------------------------------------------------+
//| GetLastClose                                                     |
//+------------------------------------------------------------------+
void GetLastClose()
  {
  int last_trade=HistoryTotal();
  if(last_trade>0)
     {
     if (OrderSelect(last_trade-1,SELECT_BY_POS,MODE_HISTORY)==true)
        {
        CurrentMinute = TimeMinute(OrderCloseTime());
        CurrentHour = TimeHour(OrderCloseTime());
        CurrentDay = TimeDay(OrderCloseTime());
        }
     }
  }
 //+------------------------------------------------------------------+
//| i_Trend Calculation                                               |
//+----------------------------------------------------------------- -+
void iTrend()
{
GetLastClose();
iTrendValue1 = NormalizeDouble(iCustom(Symbol(),0,"i_Trend",0, 0, 0, 20, 2, 13, 300, IT_V1, 0),4);
ShiftiTrendValue1 = NormalizeDouble(iCustom(Symbol(),0,"i_Trend",0, 0, 0, 20, 2, 13, 300, IT_V1, 1),4);
iTrendValue2 = NormalizeDouble(iCustom(Symbol(),0,"i_Trend",0, 0, 0, 20, 2, 13, 300, IT_V2, 0),4);
ShiftiTrendValue2 = NormalizeDouble(iCustom(Symbol(),0,"i_Trend",0, 0, 0, 20, 2, 13, 300, IT_V2, 1),4);

if (Use_iTrend == True)
{
if (iTrendValue == IT_V1 && iTrendValue1 > ShiftiTrendValue1 && iTrendValue1 > ValueLimit)
{
iTrendBuy = True;
iTrendSell = False;
}
if (iTrendValue == IT_V1 && iTrendValue1 < ShiftiTrendValue1 && iTrendValue1 > ValueLimit)
{
iTrendBuy = False;
iTrendSell = True;
}
if (iTrendValue == IT_V2 && iTrendValue2 > ShiftiTrendValue2 && (iTrendValue2*-1) > ValueLimit)
{
iTrendBuy = False;
iTrendSell = True;
}
if (iTrendValue == IT_V2 && iTrendValue2 < ShiftiTrendValue2 && (iTrendValue2*-1) > ValueLimit)
{
iTrendBuy = True;
iTrendSell = False;
}
if (iTrendValue == IT_V1_2 && iTrendValue1 > ShiftiTrendValue1 && iTrendValue2 < ShiftiTrendValue2 && iTrendValue1 > ValueLimit && (iTrendValue2*-1) > ValueLimit)
{
iTrendBuy = True;
iTrendSell = False;
}
if (iTrendValue == IT_V1_2 && iTrendValue1 < ShiftiTrendValue1 && iTrendValue2 > ShiftiTrendValue2 && iTrendValue1 > ValueLimit && (iTrendValue2*-1) > ValueLimit)
{
iTrendBuy = False;
iTrendSell = True;
}   
  }
   }
 //+------------------------------------------------------------------+
//| Bulls and Bears Power Calculation                                 |
//+----------------------------------------------------------------- -+
void BullsBearsPower()
{
GetLastClose();
BullsPower = NormalizeDouble(iBullsPower(Symbol(),0,13,PRICE_HIGH,0),7);
ShiftBullsPower = NormalizeDouble(iBullsPower(Symbol(),0,13,PRICE_HIGH,1),7);
BearsPower = NormalizeDouble(iBearsPower(Symbol(),0,13,PRICE_LOW,0),7);
ShiftBearsPower = NormalizeDouble(iBearsPower(Symbol(),0,13,PRICE_LOW,1),7);

if (Use_BullsBears == True && Use_Divergence == False)
{
if (BullsPower > ShiftBullsPower || BearsPower > ShiftBearsPower)
{
BullsPowerBuy = True;
BearsPowerSell = False;
}
if (BullsPower < ShiftBullsPower || BearsPower < ShiftBearsPower)
{
BearsPowerSell = True;
BullsPowerBuy = False;
}
   }
      }
//Divergence
void Divergence()
{
GetLastClose();
BullsDivergence = NormalizeDouble (iHighest(Symbol(),0,MODE_HIGH,DivergencePeriod,DivergencePeriod),7);
BearsDivergence = NormalizeDouble (iLowest(Symbol(),0,MODE_LOW,DivergencePeriod,DivergencePeriod),7);

for(i = DivergencePeriod; i>0;i--)
{
BullsDivergence1 = NormalizeDouble (iHighest(Symbol(),0,MODE_HIGH,i,i),7);
BearsDivergence1 = NormalizeDouble (iLowest(Symbol(),0,MODE_LOW,i,i),7);
}
if (Use_BullsBears == False && Use_Divergence == True)
{
if (BullsDivergence != BullsDivergence1 && BullsDivergence > BullsDivergence1 && BullsDivergence1 > High[1])
{
DivergenceSell = True;
DivergenceBuy = False;
}
if (BearsDivergence != BearsDivergence1 && BearsDivergence < BearsDivergence1 && BearsDivergence1 < Low[1])
{
DivergenceBuy = True;
DivergenceSell = False;
}
   }
      }
void BullsBearsMix()
{
GetLastClose();
if (Use_BullsBears == True && Use_Divergence == True)
{
if (BullsDivergence != BullsDivergence1 && BullsDivergence > BullsDivergence1 && BullsDivergence1 > High[1] && (BullsPower < ShiftBullsPower || BearsPower < ShiftBearsPower))
{
BullsBearsMixSell = True;
BullsBearsMixBuy = False;
}
if (BearsDivergence != BearsDivergence1 && BearsDivergence < BearsDivergence1 && BearsDivergence1 < Low[1] && (BullsPower > ShiftBullsPower || BearsPower > ShiftBearsPower))
{
BullsBearsMixBuy = True;
BullsBearsMixSell = False;
}
   }
      }
 //+------------------------------------------------------------------+
//| Moving Average Calculation                                        |
//+----------------------------------------------------------------- -+
void MovingAverage()
{
GetLastClose();
FastMA = NormalizeDouble (iMA(Symbol(),0,Period1,Shift1,Method1,Applied_Price1,0),7);
FastMAPrevious = NormalizeDouble (iMA(Symbol(),0,Period1,Shift1,Method1,Applied_Price1,1),7);
MediumMA = NormalizeDouble (iMA(Symbol(),0,Period2,Shift2,Method2,Applied_Price2,0),7);
SlowMA = NormalizeDouble (iMA(Symbol(),0,Period3,Shift3,Method3,Applied_Price3,0),7);

if (Use_MovingAverage == True && Use_TrixMovingAverage == False)
{
if (MovingAverageAmount == MAP1 && FastMA > FastMAPrevious)
{
MABuy = True;
MASell = False;
}
if (MovingAverageAmount == MAP1 && FastMA < FastMAPrevious)
{
MABuy = False;
MASell = True;
}
if (MovingAverageAmount == MAP2 && FastMA > MediumMA)
{
MABuy = True;
MASell = False;
}
if (MovingAverageAmount == MAP2 && FastMA < MediumMA)
{
MABuy = False;
MASell = True;
}
if (MovingAverageAmount == MAP3 && FastMA > MediumMA && MediumMA > SlowMA)
{
MABuy = True;
MASell = False;
}
if (MovingAverageAmount == MAP3 && FastMA < MediumMA && MediumMA < SlowMA)
{
MABuy = False;
MASell = True;
}
   }
      }
void Trix()
{
GetLastClose();
TrixValue1 = iCustom(Symbol(), 0, "Trix", 0, 13, 8, true, 300, 2, 0);
TrixValue2 = iCustom(Symbol(), 0, "Trix", 0, 13, 8, true, 300, 3, 0);

if (Use_MovingAverage == False && Use_TrixMovingAverage == True)
{
if (TrixValue1 != EMPTY_VALUE)
{
TrixBuy = True;
TrixSell = False;
}
if (TrixValue2 != EMPTY_VALUE)
{
TrixSell = True;
TrixBuy = False;
}
   }
      }
void MATrixMix()
{
GetLastClose();
if (Use_MovingAverage == True && Use_TrixMovingAverage == True)
{
if (((MovingAverageAmount == MAP1 && FastMA > FastMAPrevious) || (MovingAverageAmount == MAP2 && FastMA > MediumMA) || (MovingAverageAmount == MAP3 && FastMA > MediumMA && MediumMA > SlowMA)) && TrixValue1 != EMPTY_VALUE)
{
MAMixBuy = True;
MAMixSell = False;
}
if (((MovingAverageAmount == MAP1 && FastMA < FastMAPrevious) || (MovingAverageAmount == MAP2 && FastMA < MediumMA) || (MovingAverageAmount == MAP3 && FastMA < MediumMA && MediumMA < SlowMA)) && TrixValue2 != EMPTY_VALUE)
{
MAMixSell = True;
MAMixBuy = False;
}
   }
      }